<?php
/**
 * LearnDash Settings Section Emails Placeholders Metabox.
 *
 * @since 2.6.0
 * @package LearnDash\Settings\Sections
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ( class_exists( 'LearnDash_Settings_Section' ) ) && ( ! class_exists( 'LearnDash_Settings_Section_Emails_Placeholders' ) ) ) {
	/**
	 * Class LearnDash Settings Section Emails Placeholders Metabox.
	 *
	 * @since 2.6.0
	 */
	class LearnDash_Settings_Section_Emails_Placeholders extends LearnDash_Settings_Section {

		/**
		 * Public constructor for class
		 *
		 * @since 2.6.0
		 *
		 * @param array $args Array of class args.
		 */
		public function __construct( $args = array() ) {

			$this->settings_page_id = 'learndash_lms_emails';

			// This is the 'option_name' key used in the wp_options table.
			$this->setting_option_key = 'learndash_settings_emails_placeholders';

			// This is the HTML form field prefix used.
			$this->setting_field_prefix = 'learndash_settings_emails_placeholders';

			// Used within the Settings API to uniquely identify this section.
			//$this->settings_section_key = 'settings_emails_placeholders';

			// Section label/header.
			$this->settings_section_label = esc_html__( 'Email Placeholders', 'learndash' );

			$this->metabox_context  = 'side';
			$this->metabox_priority = 'default';

			parent::__construct();
		}

		/**
		 * Show custom metabox output for Quick Links.
		 *
		 * @since 2.6.0
		 */
		public function show_meta_box() {
			global $wp_meta_boxes;
			?>
			<div id="ld-emails-placeholders" class="submitbox">
				<ul>
					<li>xxx - This is the xxx laceholder</li>
					<li>yyy - This is the yyy laceholder</li>
					<li>zzz - This is the zzz laceholder</li>
			</div>
			<?php
		}

		// This is a requires function.
		public function load_settings_fields() {
		}
	}
}
